config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  devise_for :users

  resources :quizzes, except: :show do
    resources :quiz_answers, only: %i[new create]
  end
  resources :questions, only: %i[index new create destroy]

  root 'quizzes#index'
end

app/controllers/quizzes_controller.rb
# frozen_string_literal: true

class QuizzesController < ApplicationController
  before_action :set_quiz, only: %i[edit update destroy]

  def index
    @quizzes = Quiz.all
  end

  def new
    @quiz = Quiz.new
  end

  def edit; end

  def create
    @quiz = Quiz.new(quiz_params)

    respond_to do |format|
      if @quiz.save
        format.html { redirect_to quizzes_url, notice: 'Quiz was successfully created.' }
        format.json { head :created }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @quiz.errors, status: :unprocessable_entity }
      end
    end
  end

  def update
    respond_to do |format|
      if @quiz.update(quiz_params)
        format.html { redirect_to quizzes_url, notice: 'Quiz was successfully updated.' }
        format.json { head :ok }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @quiz.errors, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    respond_to do |format|
      if @quiz.destroy
        format.html { redirect_to quizzes_url, notice: 'Question was successfully destroyed.' }
        format.json { head :no_content }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @quiz.errors, status: :unprocessable_entity }
      end
    end
  end

  private

  def set_quiz
    @quiz = Quiz.find(params[:id])
    return unless @quiz.quiz_answers.any?

    respond_to do |format|
      format.html { redirect_to quizzes_url, error: 'Cannot edit a answered quiz.' }
      format.json { render json: { error: 'Cannot edit a answered quiz.' }, status: :unprocessable_entity }
    end
  end

  def quiz_params
    params.require(:quiz).permit(
      :title, :description, quiz_questions_attributes: %i[id question_id weight position _destroy]
    )
  end
end

app/views/quizzes/_form.html.erb
<%= form_for @quiz do |form| %>
  <% if @quiz.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(@quiz.errors.count, "error") %> prohibited this quiz from being saved:</h2>

      <ul>
        <% @quiz.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :title, style: "display: block" %>
    <%= form.text_field :title %>
  </div>

  <div>
    <%= form.label :description, style: "display: block" %>
    <%= form.text_field :description %>
  </div>

  <h3>Questions</h3>

  <div id="quiz_questions">
    <%= form.fields_for :quiz_questions do |quiz_question| %>
      <%= render 'quiz_question_fields', f: quiz_question %>
    <% end %>
    <%= link_to_add_association "Add question", form, :quiz_questions %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/quizzes/_quiz_question_fields.html.erb
<div class="nested-fields">
  <div>
    <%= f.label :question, style: "display: block" %>    
    <%= f.select :question_id, Question.all.map { |q| [q.statement, q.id] } %>
  </div>

  <div>
    <%= f.label :weight, style: "display: block" %>
    <%= f.text_field :weight %>
  </div>

  <div>
    <%= f.label :position, style: "display: block" %>
    <%= f.text_field :position %>
  </div>

  <%= link_to_remove_association "Delete", f %>
</div>

app/views/quizzes/edit.html.erb
<h1>Editing quiz</h1>

<%= render "form", quiz: @quiz %>

<br>

<div>  
  <%= link_to "Back", quizzes_path %>
</div>

app/views/quizzes/index.html.erb
<h1>Quizzes</h1>

<div>
  <% @quizzes.each do |quiz| %>
    <div>
      <div>
        <strong>Title:</strong>
        <%= quiz.title %>
      </div>

      <div>
        <strong>Details:</strong>
        <%= quiz.description %>
      </div>

      <% if quiz.quiz_answers.any? %>
        <strong>My scores:</strong>
        <ul>        
          <% quiz.quiz_answers.each do |quiz_answer| %>
            <li><%= quiz_answer.score %> on <%= quiz_answer.created_at %></li>
          <% end %>
        </ul>
      <% end %>

      <div>
        <%= link_to "Edit", edit_quiz_path(quiz.id) if quiz.quiz_answers.empty? %>
        <%= link_to "Delete", quiz_path(quiz.id), data: { turbo_method: :delete } if quiz.quiz_answers.empty? %>
        <%= link_to (quiz.quiz_answers.any? ? "Try again" : "Start"), new_quiz_quiz_answer_path(quiz.id) %>
      </div>
    </div>
  <% end %>
</div>

<p>
  <%= link_to "New quiz", new_quiz_path %>
</p>

app/views/quizzes/new.html.erb
<h1>New quiz</h1>

<%= render "form", quiz: @quiz %>

<br>

<div>
  <%= link_to "Back", quizzes_path %>
</div>